



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SOLID 设计原则</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SOLID 设计原则</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 01:38:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>SOLID 原则基本概念：</p>
<p>程序设计领域， SOLID (单一功能、开闭原则、里氏替换、接口隔离以及依赖反转)是由罗伯特&middot;C&middot;马丁在21世纪早期 引入的记忆术首字母缩略字，指代了面向对象编程和面向对象设计的五个基本原则。当这些原则被一起应用时，它们使得一个程序员开发一个容易进行软件维护和扩展的系统变得更加可能SOLID被典型的应用在测试驱动开发上，并且是敏捷开发以及自适应软件开发的基本原则的重要组成部分。</p>
<p><strong>[S]&nbsp;Single Responsibility Principle (单一功能原则)</strong></p>
<p>单一功能原则 ：单一功能原则 认为对象应该仅具有一种单一功能的概念。</p>
<p>换句话说就是让一个类只做一种类型责任，当这个类需要承担其他类型的责任的时候，就需要分解这个类。在所有的SOLID原则中，这是大多数开发人员感到最能完全理解的一条。严格来说，这也可能是违反最频繁的一条原则了。单一责任原则可以看作是低耦合、高内聚在面向对象原则上的引申，将责任定义为引起变化的原因，以提高内聚性来减少引起变化的原因。责任过多，可能引起它变化的原因就越多，这将导致责任依赖，相互之间就产生影响，从而极大的损伤其内聚性和耦合度。单一责任，通常意味着单一的功能，因此不要为一个模块实 现过多的功能点，以保证实体只有一个引起它变化的原因。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833855/201612/833855-20161225134507339-1405385614.png" /></p>
<div>
<pre class="prettyprint linenums">namespace SOLID<br />
{<br />
    public class Users<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// 支付<br />
        /// &lt;/summary&gt;<br />
        public void Pay(){}

        /// &lt;summary&gt;<br />
        /// 数据库操作<br />
        /// &lt;/summary&gt;<br />
        public void DataAccess(){}

        /// &lt;summary&gt;<br />
        /// 日志操作<br />
        /// &lt;/summary&gt;<br />
        public void Logger(){}<br />
    }<br />
}</pre>
</div>
<p>在这个用户类中有这三个功能：1.支付逻辑，2数据库逻辑，3.日志操作。如果将这三个功能结合在一个类中，可能会出现修改部分代码时会破坏其他的部分。多个功能也使这个用户类难以理解，降低了内聚性。所以最好就是将这个类分离为三个分离的类，每个类仅仅有一个功能。</p>
<div>
<pre class="prettyprint linenums">namespace SOLID<br />
{<br />
    /// &lt;summary&gt;<br />
    /// 数据库操作<br />
    /// &lt;/summary&gt;<br />
    class DataAccess { }<br />
    /// &lt;summary&gt;<br />
    /// 日志<br />
    /// &lt;/summary&gt;<br />
    class Logger { }<br />
    /// &lt;summary&gt;<br />
    /// 支付<br />
    /// &lt;/summary&gt;<br />
    class Pay { }<br />
}</pre>
</div>
<p><strong>[o] Open Close Principle （开闭原则）</strong></p>
<p>开闭原则(ocp) 认为&ldquo;软件体应该是对于扩展开放的，但是对于修改封闭的&rdquo;的概念。</p>
<p>软件实体应该是可扩展，而不可修改的。也就是说，对扩展是开放的，而对修改是封闭的。这个原则是诸多面向对象编程原则中最抽象、最难理解的一个。<br />对扩展开放，意味着有新的需求或变化时，可以对现有代码进行扩展，以适应新的情况。<br />对修改封闭，意味着类一旦设计完成，就可以独立完成其工作，而不要对类进行任何修改。<br />可以使用变化和不变来说明：封装不变部分，开放变化部分，一般使用接口继承实现方式来实现&ldquo;开放&rdquo;应对变化，说大白话就是：你不是要变化吗？，那么我就让你继承实现一个对象，用一个接口来抽象你的职责，你变化越多，继承实现的子类就越多。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833855/201612/833855-20161225143359198-258837981.png" /></p>
<div>
<pre class="prettyprint linenums">    abstract class DataAccess<br />
    {<br />
        public abstract void OpenConnection();<br />
        public abstract void CloseConnection();<br />
        public abstract void ExecuteCommand();<br />
    }

    /// &lt;summary&gt;<br />
    /// SQL<br />
    /// &lt;/summary&gt;<br />
    class SqlDataAccess : DataAccess<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// 打开SQL数据库<br />
        /// &lt;/summary&gt;<br />
        public override void OpenConnection(){}<br />
        /// &lt;summary&gt;<br />
        /// 关闭Sql数据连接<br />
        /// &lt;/summary&gt;<br />
        public override void CloseConnection(){}<br />
        /// &lt;summary&gt;<br />
        /// 执行Sql数据命令<br />
        /// &lt;/summary&gt;<br />
        public override void ExecuteCommand(){}<br />
    }

    /// &lt;summary&gt;<br />
    /// ORACLE<br />
    /// &lt;/summary&gt;<br />
    class OracleDataAccess : DataAccess<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// 打开Oracle数据连接<br />
        /// &lt;/summary&gt;<br />
        public override void OpenConnection(){}<br />
        /// &lt;summary&gt;<br />
        /// 关闭Oracle数据连接<br />
        /// &lt;/summary&gt;<br />
        public override void CloseConnection(){}<br />
        /// &lt;summary&gt;<br />
        /// 执行Oracle数据命令<br />
        /// &lt;/summary&gt;<br />
        public override void ExecuteCommand(){}<br />
    }</pre>
</div>
<h1>[L] Liskov Substitution Principle（里氏替换原则）</h1>
<p>里氏替换原则 ：里氏替换原则 认为&ldquo;程序中的对象应该是可以在不改变程序正确性的前提下被它的子类所替换的&rdquo;的概念。</p>
<p>软件工程大师Robert C. Martin把里氏替换原则最终简化为一句话：&ldquo;Subtypes must be substitutable for their base types&rdquo;。也就是，子类必须能够替换成它们的基类。即：子类应该可以替换任何基类能够出现的地方，并且经过替换以后，代码还能正常工作。另外，不应该 在代码中出现if/else之类对子类类型进行判断的条件。里氏替换原则LSP是使代码符合开闭原则的一个重要保证。正是由于子类型的可替换性才使得父类 型的模块在无需修改的情况下就可以扩展。在很多情况下，在设计初期我们类之间的关系不是很明确，LSP则给了我们一个判断和设计类之间关系的基准：需不需 要继承，以及怎样设计继承关系。<br />当一个子类的实例应该能够替换任何其超类的实例时，它们之间才具有is-A关系。继承对于OCP，就相当于多态性对于里氏替换原则。子类可以代替基类，客户使用基类，他们不需要知道派生类所做的事情。这是一个针对行为职责可替代的原则，如果S是T的子类型，那么S对象就应该在不改变任何抽象属性情况下替换所有T对象。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833855/201612/833855-20161225145745339-94188373.png" /></p>
<div>
<pre class="prettyprint linenums">    class Rectangle<br />
    {<br />
        protected int width = ;<br />
        protected int height = ;<br />
        public virtual void SetWidth(int width)<br />
        {<br />
            this.width = width;<br />
        }<br />
        public virtual void SetHeight(int height)<br />
        {<br />
            this.height = height;<br />
        }<br />
        public virtual int GetArea()<br />
        {<br />
            return this.width * this.height;<br />
        }<br />
    }<br />
    class Square : Rectangle<br />
    {<br />
        public override void SetHeight(int height)<br />
        {<br />
            this.height = height;<br />
            this.width = height;<br />
        }<br />
        public override void SetWidth(int width)<br />
        {<br />
            this.height = width;<br />
            this.width = width;<br />
        }<br />
    }</pre>
</div>
<p><strong>[I] Interface Segregation Principle（接口隔离原则）</strong></p>
<p>接口隔离原则 ：接口隔离原则 认为&ldquo;多个特定客户端接口要好于一个宽泛用途的接口&rdquo;的概念。</p>
<p>不能强迫用户去依赖那些他们不使用的接口。换句话说，使用多个专门的接口比使用单一的总接口总要好。注意：在代码中应用ISP并不一定意味着服务就是绝对安全的。仍然需要采用良好的编码实践，以确保正确的验证与授权。<br />这个原则起源于施乐公司，他们需要建立了一个新的打印机系统，可以执行诸如装订的印刷品一套，传真多种任务。此系统软件创建从底层开始编制，并实现了这些 任务功能，但是不断增长的软件功能却使软件本身越来越难适应变化和维护。每一次改变，即使是最小的变化，有人可能需要近一个小时的重新编译和重新部署。这 是几乎不可能再继续发展，所以他们聘请罗伯特Robert帮助他们。他们首先设计了一个主要类Job,几乎能够用于实现所有任务功能。只要调用Job类的 一个方法就可以实现一个功能，Job类就变动非常大，是一个胖模型啊，对于客户端如果只需要一个打印功能，但是其他无关打印的方法功能也和其耦合，ISP 原则建议在客户端和Job类之间增加一个接口层，对于不同功能有不同接口，比如打印功能就是Print接口，然后将大的Job类切分为继承不同接口的子 类，这样有一个Print Job类，等等。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833855/201612/833855-20161225151308167-1584307072.png" /></p>
<div>
<pre class="prettyprint linenums">    interface IDataAccess<br />
    {<br />
        void OpenConnection();<br />
        void CloseConnection();<br />
    }

    interface ISqlDataAccess : IDataAccess<br />
    {<br />
        void ExecuteSqlCommand();<br />
    }<br />
    interface IOracleDataAccess : IDataAccess<br />
    {<br />
        void ExecuteOracleCommand();<br />
    }<br />
    class SqlDataAccess : ISqlDataAccess<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// 执行Sql数据命令<br />
        /// &lt;/summary&gt;<br />
        public void ExecuteSqlCommand(){}

        /// &lt;summary&gt;<br />
        /// 打开Sql数据连接<br />
        /// &lt;/summary&gt;<br />
        public void OpenConnection(){}

        /// &lt;summary&gt;<br />
        /// 关闭Sql数据连接<br />
        /// &lt;/summary&gt;<br />
        public void CloseConnection(){}<br />
    }<br />
    class OracleDataAccess : IOracleDataAccess<br />
    {<br />
        /// &lt;summary&gt;<br />
        /// 执行Oracle数据命令<br />
        /// &lt;/summary&gt;<br />
        public void ExecuteOracleCommand(){}

        /// &lt;summary&gt;<br />
        /// 打开Oracle数据连接<br />
        /// &lt;/summary&gt;<br />
        public void OpenConnection(){}

        /// &lt;summary&gt;<br />
        /// 关闭Oracle数据连接<br />
        /// &lt;/summary&gt;<br />
        public void CloseConnection(){}<br />
    }</pre>
</div>
<h1><strong>[D] Dependency Inversion Principle（依赖反转原则）</strong></h1>
<p>依赖反转原则： 依赖反转原则 认为一个方法应该遵从&ldquo;依赖于抽象而不是一个实例&rdquo; 的概念。依赖注入是该原则的一种实现方式。</p>
<p>依赖倒置原则(Dependency Inversion Principle，DIP)规定：代码应当取决于抽象概念，而不是具体实现。<br />高层模块不应该依赖于低层模块，二者都应该依赖于抽象&nbsp;<br />抽象不应该依赖于细节，细节应该依赖于抽象&nbsp;<br />类可能依赖于其他类来执行其工作。但是，它们不应当依赖于该类的特定具体实现，而应当是它的抽象。这个原则实在是太重要了，社会的分工化，标准化都 是这个设计原则的体现。显然，这一概念会大大提高系统的灵活性。如果类只关心它们用于支持特定契约而不是特定类型的组件，就可以快速而轻松地修改这些低级 服务的功能，同时最大限度地降低对系统其余部分的影响。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/833855/201612/833855-20161225151256807-1927942307.png" /></p>
<div>
<pre class="prettyprint linenums">    interface IBankAccount<br />
    {<br />
        long BankNumber { get; set; } // 卡号<br />
        decimal Balance { get; set; } // 余额<br />
    }<br />
    // 转账人<br />
    interface ITransferSource : IBankAccount<br />
    {<br />
        void CutPayment(decimal value);<br />
    }<br />
    // 收款人<br />
    interface ITransferDestination : IBankAccount<br />
    {<br />
        void AddMoney(decimal value);<br />
    }<br />
    class BankAccout : IBankAccount, ITransferSource, ITransferDestination<br />
    {<br />
        public long BankNumber { get; set; }<br />
        public decimal Balance { get; set; }<br />
        public void CutPayment(decimal value)<br />
        {<br />
            Balance -= value;<br />
        }<br />
        public void AddMoney(decimal value)<br />
        {<br />
            Balance += value;<br />
        }<br />
    }<br />
   <br />    class TransferAmount<br />
    {<br />
        public decimal Amount { get; set; }<br />
        public void Transfer(ITransferSource source, ITransferDestination dest)<br />
        {<br />
            source.CutPayment(Amount);<br />
            dest.AddMoney(Amount);<br />
        }<br />
    }</pre>
</div>
<p>参考于：</p>
<p>http://www.cnblogs.com/Ax0ne/p/3619481.html</p>
<p>http://www.cnblogs.com/shanyou/archive/2009/09/21/1570716.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pxgedq.html">js制作简单的计算器</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq47zjnq.html">&lbrack;Gnu&rsqb;Centos7 解决 gdb 提示 Missing separate debuginfos</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e7o3m9.html">mysql的隐式转化</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7k3e19.html">安装并运行hadoop</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydvoymq.html">FileUpload控件「批次上传 &sol; 多档案同时上传」的范例--以「流水号」产生「变量名称」</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wexvoq.html">二分PKU3273</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1drwn9.html">hdu 1337 The Drunk Jailer</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnorkrq.html">Web存储&lpar;Web Storage&rpar;介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkerm08.html">iOS开发之计算文字尺寸</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey22ke9.html">linux&lowbar;RAID</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjy3vk8.html">&lpar;NO&period;00005&rpar;iOS实现炸弹人游戏&lpar;四&rpar;&colon;游戏数据的初始化&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj15pl8.html">版本管理工具Git（二）GitLab部署和配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zye6en9.html">pandas 导入导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjw5069.html">ORA-38301&colon;can not perform DDL&sol;DML over objects in Recycle Bin</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2g1j0q.html">UWP Button添加圆角阴影（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/902v0m3q.html">Java中包的介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pz575q.html">JavaScript-手机中访问页面判断</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emm3wj9.html">虚拟机安装以及PCL的配置（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em5eoz9.html">十天精通CSS3&lpar;5&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pdp05q.html">Activity生命流程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/49gee487.html">ExtJS 4&period;2 业务开发&lpar;三&rpar;数据添加和修改</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2jxw87.html">nginx的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2jrl87.html">C&plus;&plus;中的引用</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zy6x9y.html">算法与数据结构&lpar;十五&rpar; 归并排序&lpar;Swift 3&period;0版&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zvj39y.html">Tomcat启动报错org&period;springframework&period;web&period;context&period;ContextLoaderListener类配置错误&mdash;&mdash;SHH框架</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zrkvqy.html">关于CSS inline-block、BFC以及外边距合并的几个小问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96y3484.html">【Star CCM&plus;实例】开发一个简单的计算流程&period;md</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1l058g.html">如何让spring mvc web应用启动时就执行特定处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdkr79d.html">Xamarin&period;Android之Fragment Walkthrough</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qng1g8r.html">mysql集群（双主）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
